ViennaCL - The Vienna Computing Library: viennacl::scalar_expression< LHS, RHS, OP > Class Template Reference

ViennaCL - The Vienna Computing Library 1.7.1 Free open-source GPU-accelerated linear algebra and solver library. |

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Types | Public Member Functions | List of all members
viennacl::scalar_expression< LHS, RHS, OP > Class Template Reference

A proxy for scalar expressions (e.g. from inner vector products) More...

`#include <forwards.h>`

## Public Types
typedef viennacl::result_of::cpu_value_type < DummyType >::type | ScalarType

## Public Member Functions
| scalar_expression (LHS &lhs, RHS &rhs)
LHS & | lhs () const
| Returns the left hand side operand. More...
RHS & | rhs () const
| Returns the left hand side operand. More...
| operator ScalarType () const
| Conversion operator to a ViennaCL scalar. More...

## Detailed Description

### template<typename LHS, typename RHS, typename OP>
class viennacl::scalar_expression< LHS, RHS, OP >

A proxy for scalar expressions (e.g. from inner vector products)

assumption: dim(LHS) >= dim(RHS), where dim(scalar) = 0, dim(vector) = 1 and dim(matrix = 2)

Template Parameters

  LHS | The left hand side operand
  RHS | The right hand side operand
  OP | The operation tag

Definition at line 230 of file forwards.h.

## Member Typedef Documentation

template<typename LHS, typename RHS, typename OP>

typedef viennacl::result_of::cpu_value_type<DummyType>::type viennacl::scalar_expression< LHS, RHS, OP >::ScalarType

Definition at line 51 of file scalar.hpp.

## Constructor & Destructor Documentation

template<typename LHS, typename RHS, typename OP>

viennacl::scalar_expression< LHS, RHS, OP >::scalar_expression | ( | LHS & | lhs,
|  | RHS & | rhs
| ) |  |
| inline

Definition at line 53 of file scalar.hpp.

## Member Function Documentation

template<typename LHS, typename RHS, typename OP>

LHS& viennacl::scalar_expression< LHS, RHS, OP >::lhs | ( |  | ) | const
| inline

Returns the left hand side operand.

Definition at line 56 of file scalar.hpp.

template<typename LHS, typename RHS, typename OP>

viennacl::scalar_expression< LHS, RHS, OP >::operator ScalarType | ( |  | ) | const
| inline

Conversion operator to a ViennaCL scalar.

Definition at line 61 of file scalar.hpp.

template<typename LHS, typename RHS, typename OP>

RHS& viennacl::scalar_expression< LHS, RHS, OP >::rhs | ( |  | ) | const
| inline

Returns the left hand side operand.

Definition at line 58 of file scalar.hpp.

The documentation for this class was generated from the following files:

- viennacl/forwards.h
- viennacl/scalar.hpp